"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactCompoundSlider = require("react-compound-slider");

var _SliderHandleView = _interopRequireDefault(require("../sliderhandle/SliderHandleView"));

var _SliderTrackView = _interopRequireDefault(require("../slidertrack/SliderTrackView"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SliderView = function SliderView(_ref) {
  var className = _ref.className,
      onSliderValuesChange = _ref.onSliderValuesChange,
      selectedMaxValue = _ref.selectedMaxValue,
      selectedMinValue = _ref.selectedMinValue,
      sliderMaxValue = _ref.sliderMaxValue,
      sliderMinValue = _ref.sliderMinValue,
      sliderStyle = _ref.sliderStyle,
      sliderRailStyle = _ref.sliderRailStyle,
      sliderTrackStyle = _ref.sliderTrackStyle,
      sliderHandleStyle = _ref.sliderHandleStyle;
  var handleSliderUpdate = (0, _react.useCallback)(function (values) {
    if (values.length === 2) {
      onSliderValuesChange(values[0], values[1]);
    }
  }, []);

  var finalSliderStyle = _objectSpread({
    position: 'relative',
    height: '45px',
    marginLeft: '10px',
    marginRight: '10px',
    flexBasis: 'calc(100% - 20px)'
  }, sliderStyle);

  var finalSliderRailStyle = _objectSpread({
    backgroundColor: 'rgb(150, 150, 150)',
    borderRadius: '5px',
    height: '10px',
    marginTop: '18px',
    position: 'absolute',
    width: '100%'
  }, sliderRailStyle);

  return _react.default.createElement(_reactCompoundSlider.Slider, {
    className: className,
    rootStyle: finalSliderStyle,
    domain: [sliderMinValue, sliderMaxValue],
    step: 1,
    mode: 2,
    values: [selectedMinValue !== null && selectedMinValue !== void 0 ? selectedMinValue : sliderMinValue, selectedMaxValue !== null && selectedMaxValue !== void 0 ? selectedMaxValue : sliderMaxValue],
    onUpdate: handleSliderUpdate
  }, _react.default.createElement(_reactCompoundSlider.Rail, null, function (_ref2) {
    var getRailProps = _ref2.getRailProps;
    return _react.default.createElement("div", _extends({
      style: finalSliderRailStyle
    }, getRailProps()));
  }), _react.default.createElement(_reactCompoundSlider.Handles, null, function (_ref3) {
    var handles = _ref3.handles,
        getHandleProps = _ref3.getHandleProps;
    return _react.default.createElement("div", {
      className: "slider-handles"
    }, handles.map(function (handle) {
      return _react.default.createElement(_SliderHandleView.default, {
        key: handle.id,
        handle: handle,
        getHandleProps: getHandleProps,
        style: sliderHandleStyle
      });
    }));
  }), _react.default.createElement(_reactCompoundSlider.Tracks, {
    left: false,
    right: false
  }, function (_ref4) {
    var tracks = _ref4.tracks,
        getTrackProps = _ref4.getTrackProps;
    return _react.default.createElement("div", {
      className: "slider-tracks"
    }, tracks.map(function (_ref5) {
      var id = _ref5.id,
          source = _ref5.source,
          target = _ref5.target;
      return _react.default.createElement(_SliderTrackView.default, {
        key: id,
        sourceHandle: source,
        targetHandle: target,
        getTrackProps: getTrackProps,
        style: sliderTrackStyle
      });
    }));
  }));
};

SliderView.propTypes = {
  className: _propTypes.default.string,
  onSliderValuesChange: _propTypes.default.func.isRequired,
  selectedMaxValue: _propTypes.default.number,
  selectedMinValue: _propTypes.default.number,
  sliderMaxValue: _propTypes.default.number.isRequired,
  sliderMinValue: _propTypes.default.number.isRequired,
  sliderStyle: _propTypes.default.string,
  sliderRailStyle: _propTypes.default.string,
  sliderTrackStyle: _propTypes.default.string,
  sliderHandleStyle: _propTypes.default.string
};
SliderView.defaultProps = {
  className: '',
  selectedMinValue: null,
  selectedMaxValue: null,
  sliderStyle: null,
  sliderRailStyle: null,
  sliderTrackStyle: null,
  sliderHandleStyle: null
};
var _default = SliderView;
exports.default = _default;
//# sourceMappingURL=SliderView.js.map